/*
 *	Voipac boot loader head file
 */

#include "config.h"
#include "pxa-regs.h"

	.text

.globl memsetup
memsetup:
	mov	r10, lr		/* save return address */

	ldr	r0, =0x2001
	mcr	p15,0,r0,c15,c1,0	/* allow access to all coprocesors */
	nop
	nop
	nop

	mov	r0, #0x78
	mcr	p15,0,r0,c1,c0,0	/* disable MMU, caches, write buffer */
	nop
	nop
	nop

	mov	r0, #0
	mcr	p15,0,r0,c8,c7,0	/* flush v4 TLB */
	mcr	p15,0,r0,c7,c7,0	/* flush v3/v4 caches */
	mcr	p15,0,r0,c7,c10,4	/* flush write buffer */
	nop
	nop
	nop

	mvn	r0, #0
	mcr	p15,0,r0,c3,c0,0	/* grant access to all domains */

	/* initialize GPIO registers */

	ldr	r0, =GPSR0
	ldr	r1, =CFG_GPSR0_VAL
	str	r1, [r0]
	ldr	r0, =GPSR1
	ldr	r1, =CFG_GPSR1_VAL
	str	r1, [r0]
	ldr	r0, =GPSR2
	ldr	r1, =CFG_GPSR2_VAL
	str	r1, [r0]
							
	ldr	r0, =GPCR0
	ldr	r1, =CFG_GPCR0_VAL
	str	r1, [r0]
	ldr	r0, =GPCR1
	ldr	r1, =CFG_GPCR1_VAL
	str	r1, [r0]				
	ldr	r0, =GPCR2
	ldr	r1, =CFG_GPCR2_VAL
	str	r1, [r0]
										
	ldr	r0, =GPDR0
	ldr	r1, =CFG_GPDR0_VAL
	str	r1, [r0]	
	ldr	r0, =GPDR1
	ldr	r1, =CFG_GPDR1_VAL
	str	r1, [r0]						
	ldr	r0, =GPDR2
	ldr	r1, =CFG_GPDR2_VAL
	str	r1, [r0]
											
	ldr	r0, =GAFR0_L
	ldr	r1, =CFG_GAFR0_L_VAL
	str	r1, [r0]		
	ldr	r0, =GAFR0_U
	ldr	r1, =CFG_GAFR0_U_VAL
	str	r1, [r0]
	ldr	r0, =GAFR1_L
	ldr	r1, =CFG_GAFR1_L_VAL
	str	r1, [r0]
	ldr	r0, =GAFR1_U
	ldr	r1, =CFG_GAFR1_U_VAL
	str	r1, [r0]	
	ldr	r0, =GAFR2_L
	ldr	r1, =CFG_GAFR2_L_VAL
	str	r1, [r0]					
	ldr	r0, =GAFR2_U
	ldr	r1, =CFG_GAFR2_U_VAL
	str	r1, [r0]									

	.equ PWR_CTRL_BASE, 0x40f00000
	.equ PWR_CTRL_PSSR, 0x4
	
	ldr     r2, =(PWR_CTRL_BASE | PWR_CTRL_PSSR)
	ldr     r3, =CFG_PSSR_VAL
	str     r3, [r2]

	/* initialize pxa250 interupt controler */

	.equ INTERUPT_CTRL_BASE, 0x40d00000
	.equ INTERUPT_CTRL_ICMR, 0x04

	ldr	r1, =(INTERUPT_CTRL_BASE | INTERUPT_CTRL_ICMR)
	mov	r2, #0
	str	r2, [r1]

	/* change core clock frequency */

	.equ CLOCK_BASE, 0x41300000
	.equ CLOCK_CCCR, 0x0
	.equ CLOCK_CKEN, 0x4
	
	ldr	r1, =CLOCK_BASE

	mov	r2, #0
	str	r2, [r1, #CLOCK_CKEN]	/* disable clocks */

	ldr	r2, =(0x41 | CFG_CPUSPEED)	/* set core clock (L:27,M:2) */
	str	r2, [r1, #CLOCK_CCCR]

	mov	r1, #(0x2 | CFG_CPUSPEED_TURBO)
	mcr	p14,0,r1,c6,c0,0	/* enter frequency change sequence */

	/* initialize pxa250 memory controler */

	.equ MEMORY_CTRL_BASE, 0x48000000
	.equ MEMORY_CTRL_MDCNFG, 0x00
	.equ MEMORY_CTRL_MDREFR, 0x04
	.equ MEMORY_CTRL_MDMRS, 0x40

	ldr     r1, =MEMC_BASE
	
	/* initialize static memory controler */

        ldr	r2, =CFG_MSC0_VAL
	str	r2, [r1, #MSC0_OFFSET]
	ldr	r2, [r1, #MSC0_OFFSET]

	ldr	r2, =CFG_MSC1_VAL
	str	r2, [r1, #MSC1_OFFSET]
	ldr	r2, [r1, #MSC1_OFFSET]

	ldr	r2, =CFG_MSC2_VAL
	str	r2, [r1, #MSC2_OFFSET]
	ldr	r2, [r1, #MSC2_OFFSET]
	
	/* initialize pcmcia memory controler */
	
	ldr     r2, =CFG_MECR_VAL
	str     r2, [r1, #MECR_OFFSET]

	ldr     r2, =CFG_MCMEM0_VAL
	str     r2, [r1, #MCMEM0_OFFSET]

	ldr     r2, =CFG_MCMEM1_VAL
	str     r2, [r1, #MCMEM1_OFFSET]

	ldr     r2, =CFG_MCATT0_VAL
	str     r2, [r1, #MCATT0_OFFSET]

	ldr     r2, =CFG_MCATT1_VAL
	str     r2, [r1, #MCATT1_OFFSET]

	ldr     r2, =CFG_MCIO0_VAL
	str     r2, [r1, #MCIO0_OFFSET]

	ldr     r2, =CFG_MCIO1_VAL
	str     r2, [r1, #MCIO1_OFFSET]

	/* initialize SDRAM memory controler */

	ldr	r4, =0x4000000	/* init SDRAM as 64MB */
	bl	sdram_init

	mov	r0, #0
	ldr	r1, =(PHYS_SDRAM_1 + 0x2000000)	/* SDRAM bank 2 */
	ldr	r2, =(PHYS_SDRAM_1 + 0x3000000)
	
	str	r0, [r1]		/* clean both SDRAM banks */
	str	r0, [r2]

	ldr	r0, =0xdeadbeef		/* modify SDRAM bank 2 */
	str	r0, [r1]

	ldr	r1, [r2]
	cmp	r0, r1		/* compare r0, SDRAM bank 3 */
	bne	sdram_done
	
	ldr     r4, =0x2000000  /* init SDRAM as 32MB */
	bl      sdram_init

	mov     r0, #0
	ldr     r1, =(PHYS_SDRAM_1)     /* SDRAM bank 0 */

	ldr     r2, =0xdeadbeef         /* modify SDRAM bank 0 */
	str     r2, [r1]
	str	r0, [r1, #4]		/* discharge data bus */
	
	ldr     r0, [r1]
	cmp     r0, r2          /* compare r0, SDRAM bank 0 */
	beq     sdram_done

	ldr     r4, =0x1000000  /* init SDRAM as 16MB (16bit wide)*/
	bl	sdram_init

sdram_done:	/* return sdram size in r4 */
	
	/* enable peripherial clocks */

	ldr	r1, =(CLOCK_BASE | CLOCK_CKEN)
	ldr	r2, =0x17def
	str	r2, [r1]

	mov	pc, r10

	/* initialize SDRAM memory controler */

	.equ SLF_REFRESH, 0x400000
	.equ HALF_MEMCLK, 0x0a4000
	.equ MEMCLK_RUN, 0x52000
	.equ MEMCLK_ENABLE, 0x9000

	/* r0 = memory size */

sdram_init:
	ldr     r1, =MEMC_BASE

	ldr     r2, =(0x3800000 | SLF_REFRESH)
	ldr	r3, =0x0fff
	
	orr	r3, r3, r2
	str     r3, [r1, #MEMORY_CTRL_MDREFR]

	cmp	r4, #0x2000000
	orrgt	r2, r2, #0x30	/* 64MB SDRAM */
	orrle	r2, r2, #0x60	/* 32MB SDRAM */
	
	str     r2, [r1, #MEMORY_CTRL_MDREFR]	/* set data refresh rate */

	orr     r2, r2, #MEMCLK_RUN
	str     r2, [r1, #MEMORY_CTRL_MDREFR]	/* set memclk free running */

	bic	r2, r2, #SLF_REFRESH
	str     r2, [r1, #MEMORY_CTRL_MDREFR]   /* clear self refresh */

	orr	r2, r2, #MEMCLK_ENABLE
	str     r2, [r1, #MEMORY_CTRL_MDREFR]   /* enable memclk */

	.equ PART_ENABLE, 0x3
	
	.equ ROWADDR_12b, 0x20	/* 32MB SDRAM on board */
	.equ ROWADDR_13b, 0x40	/* 64MB SDRAM on board */

	.equ CAS2_RAS5_RC8, 0x100	/* 50MHz memclk */
	.equ CAS3_RAS7_RC10, 0x200	/* 100MHz memclk */
	.equ CAS3_RAS7_RC11, 0x300

	.equ DWIDTH_16BIT, 0x4		/* 16bit data bus width */
	.equ SA1111_MODE, 0x1000	/* necessary for 64MB mode */

	ldr	r2, =(0x888 | CAS3_RAS7_RC10)

	cmp     r4, #0x2000000
	orrgt   r2, r2, #ROWADDR_13b	 /* 64MB SDRAM */
	orrgt   r2, r2, #SA1111_MODE
	orrle	r2, r2, #ROWADDR_12b	 /* 32MB SDRAM */
	orrlt	r2, r2, #DWIDTH_16BIT
	
	str     r2, [r1, #MEMORY_CTRL_MDCNFG]

	mov	r3, #0x400	/* delay to wait for memory */
delay:
	nop
	nop
	subs	r3, r3, #1
	bne	delay
	nop
	nop
	nop

	orr	r2, r2, #PART_ENABLE
	str     r2, [r1, #MEMORY_CTRL_MDCNFG]

	ldr	r2, =0x220022
	str     r2, [r1, #MEMORY_CTRL_MDMRS]

	mov     pc, lr

	.align 4

